/****************************************************************************
*
*   Copyright (c) 2008 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
****************************************************************************
* modified PWM code by Afroman for www.afrotechmods.com
*
*********************************************************/
//SoR Include
#include "SoR_Utils.h" //includes all the technical stuff

char buffer[30];//stores a command
unsigned int buffer_count=0;//keeps track of newest buffer value

int a=0;
int b=0; //at least 2 global variables must be initialized to 0
		 //because GCC is a piece of shit

int main(void)
	{
	unsigned char i=0;
	unsigned char j=0;
	//declare variables here

	/****************INITIALIZATIONS*******************/
	//other stuff Im experimenting with for SoR
	uartInit();  // initialize the UART (serial port)
    uartSetBaudRate(0, 38400); // set UARTE speed, for Bluetooth
    uartSetBaudRate(1, 115200); // set UARTD speed, for USB connection
    uartSetBaudRate(2, 38400); // set UARTH speed
    uartSetBaudRate(3, 38400); // set UARTJ speed, for Blackfin
	//G=Ground, T=Tx (connect to external Rx), R=Rx (connect to external Tx)

	rprintfInit(uart1SendByte);// initialize rprintf system and configure uart1 (USB) for rprintf

	// initialize the timer system (comment out ones you don't want)
	timer0Init();
	timer1Init();
	timer2Init();
	timer3Init();
	timer4Init();
	
	configure_ports(); // configure which ports are analog, digital, etc.

	a2dInit(); // initialize analog to digital converter (ADC)
	a2dSetPrescaler(ADC_PRESCALE_DIV32); // configure ADC scaling
	a2dSetReference(ADC_REFERENCE_AVCC); // configure ADC reference voltage

	LED_on();
	delay_ms(50);
	LED_off();

	
	/*********ADD YOUR CODE BELOW THIS LINE **********/

	rprintf("Initialization Complete \r\n");

	//wait until user pushes button
	while(!button_pressed());

	//reset all timers to zero
	reset_timer_0();
	reset_timer_1();
	reset_timer_2();
	reset_timer_3();
	reset_timer_4();

	rprintf("Initializing timers for PWM\r\n");
	PWM_Init_timer2_H6(8);
	PWM_Init_timer4_H3(8);

	rprintf("Turning on both PWM channels\r\n");
	PWM_timer2_On_H6();
	PWM_timer4_On_H3();
	i=50;
	j=100;
	while(1)
		{
			for(i=0;i<255;i++)
			{
				PWM_timer2_Set_H6(i);
				PWM_timer4_Set_H3(255-i);
				delay_ms(9);
			}
			
			//wait until user pushes button
			while(!button_pressed());

			for(i=0;i<255;i++)
			{
				PWM_timer2_Set_H6(255-i);
				PWM_timer4_Set_H3(i);
				delay_ms(9);
			}
			//wait until user pushes button
			while(!button_pressed());
	
		}

	PWM_timer2_Off_H6();
	PWM_timer4_Off_H3();
	/*********ADD YOUR CODE ABOVE THIS LINE **********/

	return 0;
	}
